package name.panitz;
import static org.junit.Assert.*;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;

import org.junit.Before;
import org.junit.Test;
import java.util.List;

import static name.panitz.Interpreter.*;

public class InterpreterTest {
  Interpreter i = null;

  @Before
  public void setUp() throws Exception {
    i = new Interpreter();
  }

  @Test
  public void testNum() {
    assertEquals(42L,i.eval(new Num(42L)));
  }
  @Test
  public void testAdd() {
    assertEquals(42L,i.eval(new OpEx(new Num(20L),Op.plus,new Num(22L))));
  }
  @Test
  public void testSub() {
    assertEquals(42L,i.eval(new OpEx(new Num(60L),Op.minus,new Num(18L))));
  }
  @Test
  public void testMult() {
    assertEquals(42L,i.eval(new OpEx(new Num(2L),Op.mult,new Num(21L))));
  }
  @Test
  public void testDiv() {
    assertEquals(42L,i.eval(new OpEx(new Num(84L),Op.div,new Num(2L))));
  }
  @Test
  public void testVar1() {
    assertEquals(42L,i.eval(
      new Sequence(
        List.of(new Assign("x",new Num(21))
               ,new OpEx(new Var("x"),Op.mult,new Num(2L))
        )
      )
    )
    );
  }
  @Test
  public void testIf1() {
    assertEquals(42L,i.eval(new If(new Num(1),new Num(42),new Var("x"))));
  }
  @Test
  public void testIf2() {
    assertEquals(42L,i.eval(new If(new Num(0),"hallo",new Num(42))));
  }
  @Test
  public void testFactorial() {
    assertEquals(120L,i.eval(
      new Sequence(
        List.of(
          new Assign("x",new Num(5))
         ,new Assign("r",new Num(1))
         ,new While(new Var("x")
            ,new Sequence(List.of(
               new Assign("r",new OpEx(new Var("r"),Op.mult,new Var("x")))
              ,new Assign("x",new OpEx(new Var("x"),Op.minus,new Num(1)))
            )))
         ,new Var("r")
        )
      )
    ));
  }
}